#ifndef INCLUDED_ZOOMER_H
#define INCLUDED_ZOOMER_H

#include <stack>

#include "ZoomDimensions.h"

class Zoomer
{
	public:

		Zoomer(void);

		void setupObjectSpaceDimensions(const double & left, const double & right, const double & bottom, const double & top);

		void startZoomSelection(const double & normalized_left, const double & normalized_bottom);

		void finishZoomSelection(const double & normalized_right, const double & normalized_top);

		void pushZoom(void);

		void popZoom(void);

		void applyTopZoom(void) const;

		double getObjectSpaceX(const double & normalized_x) const;

		double getObjectSpaceY(const double & normalized_y) const;

		bool canZoomOut(void) const;

		double getLeft(void) const;
		double getRight(void) const;
		double getBottom(void) const;
		double getTop(void) const;

		double getHorizontalRange(void) const;
		double getVerticalRange(void) const;

		double getIncompleteZoomLeft(void) const;
		double getIncompleteZoomRight(void) const;
		double getIncompleteZoomBottom(void) const;
		double getIncompleteZoomTop(void) const;

		bool isZoomCompleted(void) const;

	private:

		static const double THROW_AWAY_ZOOM_TOLERANCE;

		ZoomDimensions m_incomplete_zoom;

		bool m_zoom_completed;

		std::stack<ZoomDimensions> m_zoom_history;
};

#endif